#include "PICS_PreferencesPanes.h"
#include "PICSViewer.h"

enum {
	// Animation method pane
	kAnimPane_UsePictureRadio = kPrefsDlog_LastItem,
	kAnimPane_UseMonitorRadio,
	
	kAnimPane_LineSeparator,
	kAnimPane_Box
};

// ---------------------------------------------------------------------------

void PrefsDialogSetupAnimPane(DialogPtr prefsDlog) {
	// Set animation method
	if ((**sPrefsData->prefs).animationMethod == kUseMonitorGWorldMethod) {
		SelectRadioBtn(prefsDlog, kAnimPane_UseMonitorRadio,
			kAnimPane_UsePictureRadio, kAnimPane_UseMonitorRadio);
	}
	else if ((**sPrefsData->prefs).animationMethod == kUsePictureGWorldMethod) {
		SelectRadioBtn(prefsDlog, kAnimPane_UsePictureRadio,
			kAnimPane_UsePictureRadio, kAnimPane_UseMonitorRadio);
	}
} // END PrefsDialogSetupAnimPane

// ---------------------------------------------------------------------------

Boolean PrefsDialogGetAnimPaneSettings(DialogPtr prefsDlog) {
	if (GetDlogCtlValue(prefsDlog, kAnimPane_UseMonitorRadio)) {
		(**sPrefsData->prefs).animationMethod = kUseMonitorGWorldMethod;
	}
	else {
		(**sPrefsData->prefs).animationMethod = kUsePictureGWorldMethod;
	}
	
	return(true);
} // END PrefsDialogGetAnimPaneSettings

// ---------------------------------------------------------------------------

void PrefsDialogAnimPaneHit(DialogPtr prefsDlog, short itemHit) {
	switch(itemHit) {
		case kAnimPane_UseMonitorRadio:
		case kAnimPane_UsePictureRadio:
			SelectRadioBtn(prefsDlog, itemHit,
				kAnimPane_UsePictureRadio, kAnimPane_UseMonitorRadio);
		break;
	}
} // END PrefsDialogAnimPaneHit

// ---------------------------------------------------------------------------

void PrefsDialogAnimPaneUpdate(DialogPtr prefsDlog, EventRecord *theEvt, Boolean frontMost) {
	Rect lineRect;
	
	GetDItemRect(prefsDlog, kAnimPane_Box, &lineRect);
	GrayDrawShadowBox(&lineRect, NULL);
	
	GetDItemRect(prefsDlog, kAnimPane_LineSeparator, &lineRect);
	GrayDrawShadowLine(&lineRect, NULL);
} // END PrefsDialogAnimPaneUpdate

// ---------------------------------------------------------------------------

void PrefsDialogAnimPaneActivate(DialogPtr prefsDlog, Boolean activate) {
	short hiliteMode = activate ? 0 : 255;
	
	for (short i = kAnimPane_UsePictureRadio;
		i <= kAnimPane_UseMonitorRadio; i++) {
		HiliteControl((ControlHandle)GetDItemHdl(prefsDlog, i), hiliteMode);
	}
} // END PrefsDialogAnimPaneActivate
