#include "DialogUtils.h"
#include "MovableModalDialogs.h"
#include "PICSPreferencesDialog.h"
#include "PICS_Operations.h"
#include "PICSDialogs.h"
#include "GrayDraw 3d.h"

enum {
	kPrefsDlogID = 129,					// Rsrc id of DLOG

	kPrefsPaneListDefID = 1972,			// Rsrc id of icl8 LDEF

	// DITL resource ids
	kOpenFilePaneID		= 1290,
	kDragPaneID,
	kCreatorPaneID,
	kCompositePaneID,
	kAnimPaneID,
	kMarqueePaneID,
	
	kFirstPaneID = kOpenFilePaneID,
	kLastPaneID = kMarqueePaneID,
	kNumPanes = kLastPaneID - kFirstPaneID + 1
};

// ---------------------------------------------------------------------------

enum {
	// Overall pane
	kPrefsDlog_OKBtn = 1,
	kPrefsDlog_CancelBtn,
	kPrefsDlog_DefaultBtn,
	kPrefsDlog_PaneList,
	kPrefsDlog_PaneSeparatorLine,
	kPrefsDlog_LastItem
};


// ---------------------------------------------------------------------------

enum {
	kMarqueeUseHiliteColor,
	kMarqueeUseBlackColor,
	kMarqueeUseCustomColor
};

// ---------------------------------------------------------------------------

/*
typedef void (*PaneSwitchHandler)(void);

typedef struct {
	short					paneID;
	DialogHitHandler		paneHitProc;
	DialogKeyHandler		paneKeyProc;
	DialogUpdateHandler		paneUpdateProc;
	DialogActivateHandler	paneActivateProc;
	DialogIdleHandler		paneIdleProc;
	PaneSwitchHandler		paneSwitchProc;
} PaneData;
*/

typedef struct {
	short lastPaneUsed;
	ListHandle paneList;
	PrefsHandle prefs;
	//PaneData panes[kNumPanes];
} PrefsData;

extern PrefsData *sPrefsData;

// ---------------------------------------------------------------------------

// Open file pane
void PrefsDialogSetupOpenFilePane(DialogPtr prefsDlog);
Boolean PrefsDialogGetOpenFilePaneSettings(DialogPtr prefsDlog);
void PrefsDialogOpenFilePaneHit(DialogPtr prefsDlog, short itemHit);
void PrefsDialogOpenFilePaneUpdate(DialogPtr prefsDlog, EventRecord *theEvt, Boolean frontMost);
void PrefsDialogOpenFilePaneActivate(DialogPtr prefsDlog, Boolean activate);

// Drag pane
void PrefsDialogSetupDragPane(DialogPtr prefsDlog);
Boolean PrefsDialogGetDragPaneSettings(DialogPtr prefsDlog);
void PrefsDialogDragPaneHit(DialogPtr prefsDlog, short itemHit);
void PrefsDialogDragPaneUpdate(DialogPtr prefsDlog, EventRecord *theEvt, Boolean frontMost);
void PrefsDialogDragPaneActivate(DialogPtr prefsDlog, Boolean activate);

// Composite pane
void PrefsDialogSetupCompositePane(DialogPtr prefsDlog);
Boolean PrefsDialogGetCompositePaneSettings(DialogPtr prefsDlog);
void PrefsDialogCompositePaneHit(DialogPtr prefsDlog, short itemHit);
void PrefsDialogCompositePaneUpdate(DialogPtr prefsDlog, EventRecord *theEvt, Boolean frontMost);
void PrefsDialogCompositePaneActivate(DialogPtr prefsDlog, Boolean activate);

// Anim pane
void PrefsDialogSetupAnimPane(DialogPtr prefsDlog);
Boolean PrefsDialogGetAnimPaneSettings(DialogPtr prefsDlog);
void PrefsDialogAnimPaneHit(DialogPtr prefsDlog, short itemHit);
void PrefsDialogAnimPaneUpdate(DialogPtr prefsDlog, EventRecord *theEvt, Boolean frontMost);
void PrefsDialogAnimPaneActivate(DialogPtr prefsDlog, Boolean activate);

// Creator pane
void PrefsDialogSetupCreatorPane(DialogPtr prefsDlog);
Boolean PrefsDialogGetCreatorPaneSettings(DialogPtr prefsDlog);
void PrefsDialogCreatorPaneHit(DialogPtr prefsDlog, short itemHit);
void PrefsDialogCreatorPaneUpdate(DialogPtr prefsDlog, EventRecord *theEvt, Boolean frontMost);
void PrefsDialogCreatorPaneActivate(DialogPtr prefsDlog, Boolean activate);

// Marquee pane
void PrefsDialogSetupMarqueePane(DialogPtr prefsDlog);
Boolean PrefsDialogGetMarqueePaneSettings(DialogPtr prefsDlog);
void PrefsDialogMarqueePaneHit(DialogPtr prefsDlog, short itemHit);
void PrefsDialogMarqueePaneUpdate(DialogPtr prefsDlog, EventRecord *theEvt, Boolean frontMost);
void PrefsDialogMarqueePaneActivate(DialogPtr prefsDlog, Boolean activate);
