#ifndef CLASS_PROGRESSWINDOW_H_
#define CLASS_PROGRESSWINDOW_H_

#ifndef CLASS_PROGRESSBAR_H_
#include "Class_ProgressBar.h"
#endif

typedef class ProgressWindow {
	public:
		ProgressWindow(GDHandle targetMonitor, short maxValue);
		~ProgressWindow();

		virtual void Update();
		virtual void Increment();
		virtual void IncrementBy(short stepValue);
		virtual void IncrementTo(short curValue);
		virtual void SetPrimaryMessage(Str255 message);
		virtual void SetSecondaryMessage(Str255 message);
		
		virtual WindowRef GetWindow() { return(this->progressWindow); }
		virtual void SetReadDelay(unsigned short readDelay) { this->readDelay = readDelay; }
		virtual void FinishProgress();

	protected:
		ProgressBarPtr progressBar;
		WindowPtr progressWindow;
		Str255 primaryStr;
		Str255 secondaryStr;
		unsigned short readDelay;
		
		void DrawPrimaryString();
		void DrawSecondaryString();
} *ProgressWindowPtr, **ProgressWindowHdl;

#endif // CLASS_PROGRESSWINDOW_H_