#ifndef MONITORS_H_
#define MONITORS_H_

/*
	Written by Norman Basham, Feb. 1994
	With very minor changes by Hiep Dam, Sept. 1994
	
	Version History
		1.1 Nov 1 95 HTD
			Added GetDeepestDevice();
*/

//	PROTOTYPES
//	------------------------------------------------------------------------

//	WINDOW STUFF
	void Place (WindowPtr wp, short place);
	void GetCenteredWindowTopLeft (WindowPtr wp, const Rect screenRect, short *top, short *left);
	void Move (WindowPtr wp, short top, short left);
	short GetDragBarHeight (WindowPtr wp);

//	DEVICE STUFF
	Rect GetDeviceGRect (GDHandle gdh);
	Rect GetDeepDeviceGRect ();
	GDHandle GetDominantDevice (Rect *r);
	GDHandle GetBigDevice (void);
	short GetDeviceDepth (GDHandle gdh);
	GDHandle GetDeviceWithThisDepth (short depth);
	Boolean IsActiveScreenDevice (GDHandle theDevice);
	Boolean IsMainDevice (GDHandle theDevice);
	
	GDHandle GetDeepestDevice();

//	RECT STUFF
	void GlobalToLocalRect (Rect *r);
	long GetRectArea (Rect r);
	void ZeroTopLeft (Rect *r);
	void SetTopLeft (Rect *r, short top, short left);
	void CenterRect (const Rect centerOnRect, Rect *rectToCenter);

	
//	------------------------------------------------------------------------

// CONSTANTS used by Place()
 enum
 	{
 	kOnBigDevice = 1,
 	kOnDeepDevice,
 	kCenterOnDeepDevice,
 	kOnMainDevice,
 	kCenterOnMainDevice
 	};

#endif // MONITORS_H_