#include "OSTypes.h"

#include "assert_mac.h"

// ---------------------------------------------------------------------------

Boolean GetAppCreatorType(OSType *type) {
	StandardFileReply reply;
	SFTypeList typeList;
	
	ASSERT(type != NULL);

	typeList[0] = 'APPL';
	StandardGetFile(NULL, 1, typeList, &reply);

	if (reply.sfGood) {
		FInfo fileInfo;
		OSErr osErr;
		osErr = FSpGetFInfo(&reply.sfFile, &fileInfo);
		*type = fileInfo.fdCreator;
		return(true);
	}
	else
		return(false);
} // END GetAppCreatorType

// ---------------------------------------------------------------------------

void OSTypeToString(OSType type, Str15 osStr) {
	osStr[0] = 4;
	BlockMove(&type, &osStr[1], sizeof(OSType));
} // END OSTypeToString

// ---------------------------------------------------------------------------

void StringToOSType(Str15 osStr, OSType *type) {
	BlockMove(&osStr[1], type, sizeof(OSType));
} // END StringToOSType